
##
# OS Templates for creating new virtual machines.
#
# @author::  Alan Vella
##

class OsTemplate


  def initialize(name, version, minimumStorageSpace, defaultAdministratorUsername, diskExpandable)
    @name = name
    @version = version
    @minimumStorageSpace = minimumStorageSpace
    @defaultAdministratorUsername = defaultAdministratorUsername
    @diskExpandable = diskExpandable
  end
    
    
  def get_details()
    details =  "Name                       : #{@name}\n"
    details += "Version                    : #{@version}\n"
    details += "Minimum Storage Space in Gb: #{@minimumStorageSpace}\n"
    details += "Default Admin Username     : #{@defaultAdministratorUsername}\n"
    details += "Disk Expandable            : #{@diskExpandable}\n"
    return details
  end
  
  
  def get_name
    return @name
  end
  
  def get_version
    return @version
  end
  
  def get_minimum_storage_space
    return @minimumStorageSpace
  end
  
  def get_administrator_username
    return @defaultAdministratorUsername
  end
  
  def get_disk_expandable
    return @diskExpandable
  end
  
  
end