
##
# Class SecuredCloudConnection stores the details of a connection to the Secured Cloud API. 
# An object of this type is needed whenever making calls to the API.
#
# @author::  Alan Vella
##

class SecuredCloudConnection
  
  #The URL must be in the format "http://10.239.32.201:8080/cloud-external-api-rest"
  def initialize(url, applicationKey, sharedSecret)
    
    #validation
    raise ArgumentError, 'SecuredCloudConnection URL needs to be initialized' unless url != nil
    raise ArgumentError, 'SecuredCloudConnection URL needs to be a valid string' unless url.respond_to?(:to_str)
    raise ArgumentError, 'SecuredCloudConnection applicationKey needs to be initialized' unless applicationKey != nil
    raise ArgumentError, 'SecuredCloudConnection applicationKey needs to be a valid string' unless applicationKey.respond_to?(:to_str)
    raise ArgumentError, 'SecuredCloudConnection sharedSecret needs to be initialized' unless sharedSecret != nil
    raise ArgumentError, 'SecuredCloudConnection sharedSecret needs to be a valid string' unless sharedSecret.respond_to?(:to_str)

    @url = url
    @applicationKey = applicationKey
    @sharedSecret = sharedSecret
    
  end
  
  
  def getUrl
    return @url
  end
  
  
  def getApplicationKey
    return @applicationKey
  end
  
  
  def getSharedSecret
    return @sharedSecret
  end
  
end