
##
# Status of asynchronous tasks in Secured Cloud.
#
# @author::  Alan Vella
##

class TaskStatus


  def initialize(percentageComplete, requestStateEnum, result, errorCode, errorMessage, latestTaskDescription, processDescription, createdTimestamp, lastUpdatedTimeStamp)
    @percentageComplete = percentageComplete
    @requestStateEnum = requestStateEnum
    @result = result
    @errorCode = errorCode
    @errorMessage = errorMessage
    @latestTaskDescription = latestTaskDescription
    @processDescription = processDescription
    @createdTimestamp = createdTimestamp
    @lastUpdatedTimeStamp = lastUpdatedTimeStamp
    
    #Handle bum messages
    if (@errorMessage == "DC VCPU Allocation not defined for VDC: %s") then
      @errorMessage = "VCPU Allocation not defined for this node"
    elsif (@errorMessage == "VDC Memory Allocation not defined for VDC: %s") then
      @errorMessage = "Memory Allocation not defined for this node"
    elsif (@errorMessage == "VDC Storage Allocation not defined for VDC: %s") then
      @errorMessage = "Storage Allocation not defined for this node"
    end
    
  end
  
  
  def get_details()
    details  = "Percentage Complete    : #{@percentageComplete}\n"
    details += "Request State          : #{@requestStateEnum}\n"
    details += "Result                 : #{@result}\n"
    details += "Error Code             : #{@errorCode}\n"
    details += "Error Message          : #{@errorMessage}\n"
    details += "Latest Task Description: #{@latestTaskDescription}\n"
    details += "Process Description    : #{@processDescription}\n"
    details += "Created Timestamp      : #{@createdTimestamp}\n"
    details += "Last Updated Timestamp : #{@lastUpdatedTimeStamp}\n"
    return details
  end


  def get_result
    return (@result.nil?) ? nil : @result["resourceURL"]
  end
  
  def get_error_code
	return @errorCode
  end
  
  
  def get_error_message
	return @errorMessage
  end
  
  
  def get_percentage_completed
    return @percentageComplete
  end
  
  
  def get_latest_task_description
    return @latestTaskDescription
  end
  
  
end