
##
# Virtual machines.
#
# @author::  Alan Vella
##

class VirtualMachine


  def initialize(name, description, storageGB, storageType, memoryMB, vCPUs, powerStatus, nodeResource, organizationResource,
    operatingSystemTemplate, imageResource, disks, macAddress, deducedPrivateIps, ipMappings)
    @name = name
    @description = description
    @storageGB = storageGB
    @storageType = storageType
    @memoryMB = memoryMB
    @vCPUs = vCPUs
    @powerStatus = powerStatus
    @nodeResource = nodeResource
    @organizationResource = organizationResource
    @operatingSystemTemplate = operatingSystemTemplate
    @imageResource = imageResource
    @disks = disks
    @macAddress = macAddress
    @deducedPrivateIps = deducedPrivateIps
    @ipMappings = ipMappings
  end
  
  
  def get_details()
    details  = "Name                     : #{@name}\n"
    details += "Description              : #{@description}\n"
    details += "Storage (GB)             : #{@storageGB}\n"
    details += "Storage Type             : #{@storageType}\n"
    details += "Memory (Mb)              : #{@memoryMB}\n"
    details += "vCPUs                    : #{@vCPUs}\n"
    details += "Power Status             : #{@powerStatus}\n"
    details += "Node Resource            : #{@nodeResource}\n"
    details += "Organization Resource    : #{@organizationResource}\n"
    details += "Operation System Template: #{@operatingSystemTemplate}\n"
    details += "Image Resource           : #{@imageResource}\n"
    if (@disks == nil) then
      details += "Disks                    : -\n"
    else
      details += "Disks                    : #{@disks.join(", ")}\n"
    end
    if (@deducedPrivateIps == nil) then
      details += "Deduced Private IPs      : -\n"
    else
      details += "Deduced Private IPs      : #{@deducedPrivateIps.join(", ")}\n"
    end
    details += "IP Mappings:"
    @ipMappings.each do |ipMapping|
      details += "\n\t#{ipMapping.get_details()}"
    end
    details += "\nMAC Address              : #{@macAddress}\n"
    return details
  end

  
  def get_power_status
    return @powerStatus
  end
  
  
  def get_os_template_resource_url
    return @operatingSystemTemplate
  end
  
  
  def get_image_resource_url
    return @imageResource
  end
  
  
  def get_ip_mappings
    return @ipMappings
  end
  
  
  def get_name
    return @name
  end


end